/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "alphCRYPT.h"

char 
*feistel(char *org, char *key)
{

  char *tmp_key;

	unsigned char *tmp;
	unsigned int *left[2], *right[2], *dst;
	unsigned int *org_d, *key_d;
	int itra=0, itrb=0, itrc=0, itrd=0, size=0;

	org_d = (int *) calloc(strlen(org), sizeof(int));
	if(al_dec)
	{
		org_d=decode_base64(org);
		for(itra=0, itrb=0; org_d[itra]; itra++)
			org_d[itrb++]=org_d[itra];
	}
	else
	{
		for(itra=0; itra<strlen(org); itra++)
			org_d[itra]=(int ) org[itra];
	}

	for(size=0; org_d[size]; size++);

  /* linear forward shift */

  tmp_key = (char *) calloc(64, sizeof(char));
  strncat(tmp_key, key, 64);
  if(strlen(tmp_key)<64)
    {
      for(itra=strlen(tmp_key); itra<64; itra++)
        {
          tmp_key[itra]=tmp_key[itra-1]-tmp_key[itra-2];
        }
    }

	key_d = (int *) calloc(strlen(tmp_key), sizeof(int));

	for(itra=0; itra<strlen(tmp_key); itra++)
		key_d[itra]=(int ) tmp_key[itra];

	for(itra=0; itra<2; itra++)
		left[itra]= (int *) calloc(strlen(org), sizeof(int));
	for(itra=0; itra<2; itra++)
		right[itra] = (int *) calloc(strlen(org), sizeof(int));

	for(itra=0, itrb=0, itrc=0; itra<size; itra++)
		if(itra<size/2)
			left[0][itrb++]=org_d[itra];
		else
			right[0][itrc++]=org_d[itra];

	for(itra=1, itrb=itra-1, itrd=0; itrd<strlen(tmp_key) && !al_dec; itrd++)
	{

		left[itra]=right[itrb];

		for(itrc=0; itrc<size/2; itrc++)
		   right[itra][itrc]=left[itrb][itrc]^right[itrb][itrc]^key_d[itrd];

		itrc=itrb;
		itrb=itra;
		itra=itrc;			

	}

	for(itra=1, itrb=itra-1, itrd=strlen(tmp_key)-1; itrd>-1 && al_dec; itrd--)
	{

		for(itrc=0; itrc<size/2; itrc++)
		   left[itra][itrc]=right[itrb][itrc]^left[itrb][itrc]^key_d[itrd];

		right[itra]=left[itrb];

		itrc=itrb;
		itrb=itra;
		itra=itrc;

	}

	dst = (int *) calloc(2*strlen(org), sizeof(int));

	for(itrc=0, itrb=0; itrc<size/2; itrc++)
		dst[itrb++]=right[itra][itrc];
	for(itrc=0; itrc<size/2; itrc++)
		dst[itrb++]=left[itra][itrc];

	if(!al_dec)
	{
		tmp = (char *) calloc(3*strlen(org), sizeof(char));
		tmp=base64(dst);
	}
	else 
	{
		tmp = (char *) calloc(strlen(org), sizeof(char));
		/* nahasty fix */
		dst[itrb-1]='\0';
		for(itra=0, itrb=0; itra<strlen(org); itra++)
			tmp[itrb++]=(char ) dst[itra];
	}
	
	return tmp;

}

