/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "alphCRYPT.h"

char *
mdelvayo(char *org, char *key)
{

  int itra, itrb, itrc, ptr; 
  char alp;
  char *cb[3];
  char *cbuf;
  int hlp;

  char *dst;

  if(!strlen(key) || strlen(key)>10)
    printf("key error\n"), exit(0);

  /* initialise checkerboard */

  for(itra=0; itra<3; itra++)
    cb[itra]=(char *) calloc(10, sizeof(char));

  for(itra=0; itra<strlen(key); itra++)
    if(isalpha(key[itra]))
      cb[0][itra]=tolower(key[itra]);

  /* generate checkerboard */

  for(alp='a', itra=0, ptr=1, itrb=0; itra<26; itra++)
    {
      if(!strchr(key, alp))
        cb[ptr][itrb++]=alp;
      alp++;
      if(itrb==10)
        {
          ptr++;
          itrb=0;
        }
    }

  /* generate output message */
  dst = (char *) calloc(strlen(org)*2, sizeof(char));
  for(itra=0, itrc=0; itra<strlen(org) && !al_dec; itra++)
    {
      cbuf=(char *) calloc(4, sizeof(char));
      if(strchr(cb[0], org[itra]))
        {
          for(itrb=0; itrb<10; itrb++)
            if(org[itra]==cb[0][itrb])
              {
                sprintf(cbuf, "%i", 10-itrb==10 ? 0 : 10-itrb);
                strcat(dst, cbuf);
                break;
              }
        }
      else if(strchr(cb[1], org[itra]))
        {
          for(itrb=0; itrb<10; itrb++)
            if(org[itra]==cb[1][itrb])
              {
                sprintf(cbuf, "%i%i", 1, 10-itrb==10 ? 0 : 10-itrb);
                strcat(dst, cbuf);
              }
        }
      else if(strchr(cb[2], org[itra]))
        {
          for(itrb=0; itrb<10; itrb++)
            if(org[itra]==cb[2][itrb])
              {
                sprintf(cbuf, "%i%i", 2, 10-itrb==10 ? 0 : 10-itrb);
                strcat(dst, cbuf);
              }
        }
      else if(!isalpha(org[itra]))
        dst[strlen(dst)]=org[itra];
      else
        {
          fault(KEYB, "Key doesn't generate enough entropy.");
        }
    }
  
  for(itra=0, itrc=0; itra<strlen(org) && al_dec; itrc++)
    {
      if(org[itra]=='2' || org[itra]=='1')
        {
          dst[itrc]=cb[org[itra]-'0'][10-(org[itra+1]-'0')==10 ? 0 : 10-(org[itra+1]-'0')];
          itra+=2;
        }
      else if(isdigit(org[itra]))
        {
          dst[itrc]=cb[0][10-(org[itra]-'0')==10 ? 0 : 10-(org[itra]-'0')];
          itra++;
        }
      else if(!isdigit(org[itra]))
        {
          dst[itrc]=org[itra];
          itra++;
        }
    }
	
  return dst;

}
