/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
	      programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "alphCRYPT.h"

char 
*nihilist(char *org, char *key_a, char *key_b)
{

  int itra, itrb;
  int loc_x, loc_y, poc_x, poc_y;
  char *p_key, *x_key;

  char lph;
  int sem;

  char pb[5][5];

  char *c_buf;
  int *i_buf;
  int size;
  char *dst;

  /* Generate polybus key */
  p_key=(char *) calloc(strlen(key_a), sizeof(char));
  for(itra=0, itrb=0; itra<strlen(key_a); itra++)
    if(isalpha(key_a[itra]) && !strchr(p_key, key_a[itra]))
      p_key[itrb++]=tolower(key_a[itra]);

  /* Initialize polybus square */
  for(loc_y=0; loc_y<5; loc_y++)
    for(loc_x=0; loc_x<5; loc_x++)
      pb[loc_y][loc_x]=0;

  /* Generate polybus square */
  for(loc_y=0, lph='a', itra=0; loc_y<5; loc_y++)
    for(loc_x=0; loc_x<5; loc_x++)
      {
        if(isalpha(p_key[itra]))
          pb[loc_y][loc_x]=p_key[itra++];
        else
          {
            while(lph<'z')
              {
                for(poc_y=0, sem=0; poc_y<5; poc_y++)
                  for(poc_x=0; poc_x<5; poc_x++)
                    if(pb[poc_y][poc_x]==lph)
                      {
                        sem++;
                        break;
                      }
                if(sem)
                  lph++;
                else
                  break;
              }

            if(!sem)
               pb[loc_y][loc_x]=lph++;
            else
              lph++;
          }
      }

  /* Check entropy if we encrypt */
  for(itra=0, sem=0; itra<strlen(org) && !al_dec; itra++)
    {
      for(loc_y=0; loc_y<5; loc_y++)
        for(loc_x=0; loc_x<5; loc_x++)
          if(isalpha(org[itra]) && tolower(org[itra])!=pb[loc_y][loc_x])
            {            
              sem++;
            }

      if(sem==24 || !isalpha(org[itra]))
        sem=0;
      else
        fault(ENTO, "The primary key does not contain some of the letters in the original message.");
    }    
  /* Purify second key */
  p_key=(char *) calloc(strlen(key_b), sizeof(char));
  for(itra=0, itrb=0; itra<strlen(key_b); itra++)
    if(isalpha(key_b[itra]))
      p_key[itrb++]=tolower(key_b[itra]);

  /* Expand second key */
  for(loc_x=0, loc_y=0; loc_x<strlen(org); loc_x++)
    if(isalpha(org[loc_x]) && !al_dec)
      loc_y++;
    else if(isdigit(org[loc_x]) && al_dec)
      loc_y++;
  x_key=(char *) calloc(strlen(org), sizeof(char));
  for(itra=0, itrb=0; itra<loc_y; itra++)
    {
      if(!isalpha(p_key[itrb]))
        itrb=0;
      x_key[itra]=p_key[itrb++];
    }
  /* Start encryption */
  dst=(char *) calloc(strlen(org)*2, sizeof(char));
  for(itra=0, sem=0, itrb=0; itra<strlen(org) && !al_dec; itra++)
    {
      /* Search expanded key. */
      if(isalpha(org[itra]))
        {
          for(loc_y=0; loc_y<5; loc_y++)
            for(loc_x=0; loc_x<5; loc_x++)
              if(pb[loc_y][loc_x]==x_key[itra-sem])
                {
                  poc_x=loc_x;
                  poc_y=loc_y;
                }
          for(loc_y=0; loc_y<5; loc_y++)
            for(loc_x=0; loc_x<5; loc_x++)
              if(pb[loc_y][loc_x]==tolower(org[itra]))
                {
                  c_buf=(char *) calloc(2, sizeof(char));
                  sprintf(c_buf, "%i%i", poc_x+loc_x, poc_y+loc_y);
                }
          strcat(dst, c_buf);
         }
        else
         {
          dst[strlen(dst)]=org[itra];
          sem++;
         }
    }

  /* Or decryption. */
  i_buf=(int *) calloc(strlen(org), sizeof(int));
  for(itra=0, loc_x=0; itra<strlen(org) && al_dec; itra++)
    if(isdigit(org[itra]))
      i_buf[loc_x++]=org[itra]-'0';
  size=loc_x;

  c_buf=(char *) calloc(strlen(org), sizeof(char));
  for(itra=0, itrb=0, sem=0; itra<strlen(org) && al_dec; itra++)
    {
      if(itrb==size)
        break;

      if(isdigit(org[itra]))
        {
          for(loc_y=0; loc_y<5; loc_y++)
            for(loc_x=0; loc_x<5; loc_x++)
              if(pb[loc_y][loc_x]==x_key[itra-sem])
                {
                  poc_x=loc_x;
                  poc_y=loc_y;
                }
          c_buf[strlen(c_buf)]=pb[i_buf[itrb+1]-poc_y][i_buf[itrb]-poc_x];
          itrb+=2;
        }
      else
        sem++;
    }
  for(itra=0, itrb=0, loc_x=0, sem=0; itra<strlen(org) && al_dec; itra++)
    {
      if(isdigit(org[itra]) && !sem)
        {
          dst[itrb++]=c_buf[loc_x++];
          sem++;
        }
      else
        {
          if(!isdigit(org[itra]))
            dst[itrb++]=org[itra];
          sem=0;
        }
    }

  return dst;

}
