/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

/*      UNIX ELF hash
        Published hash algorithm used in the UNIX ELF format for object files
*/

#include "alphCRYPT.h"

unsigned long unixhash(char *org)
{
	unsigned long h = 0, g;

	while ( *org ) {
		h = ( h << 4 ) + *org++;
		if ( g = h & 0xF0000000 )
		h ^= g >> 24;
		h &= ~g;
	}

	return h;
}
